Package: KernelICA
Type: Package
Title: Kernel Independent Component Analysis
Version: 2.0.0
Authors@R: 
  c(person(
      given = "Christoph L.",
      family = "Koesner",
      role = "aut",
      email = "christoph@koesner.at",
      comment = c(ORCID = "0000-0002-2061-8022")),
    person(
      given = "Juho",
      family = "Eagling", 
      email = "juho.eagling@gmail.com",
      role = "aut",
      comment = c(ORCID = "0000-0001-8333-5057")),
    person(
      given = "Klaus",
      family = "Nordhausen",
      role = c("aut", "cre"),
      email = "klausnordhausenR@gmail.com",
      comment = c(ORCID = "0000-0002-3758-8501")))
Maintainer: Klaus Nordhausen <klausnordhausenR@gmail.com>
Description: 
  The kernel independent component analysis (kernel ICA) method introduced by Bach and Jordan (2002) <doi:10.1162/153244303768966085>. A separate function for the incomplete Cholesky decomposition used in kernel ICA is also provided.
License: GPL (>= 2)
Imports: methods, ManifoldOptim, JADE, ICtest
Depends: Rcpp, R (>= 4.2.0)
LinkingTo: Rcpp, RcppArmadillo, ManifoldOptim, RcppEigen
Encoding: UTF-8
Config/roxygen2/version: 8.0.0
NeedsCompilation: yes
Packaged: 2026-08-03 07:34:26 UTC; klaus
Author: Christoph L. Koesner [aut] (ORCID:
    <https://orcid.org/0000-0002-2061-8022>),
  Juho Eagling [aut] (ORCID: <https://orcid.org/0000-0001-8333-5057>),
  Klaus Nordhausen [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-3758-8501>)
Repository: CRAN
Date/Publication: 2026-08-04 08:50:12 UTC

#' MD Distant Matrices
#'
#' Creates orthogonal matrices in the Stiefel manifold, which are distant to each other
#' by the MD index and optionally also distant to a given set of matrices.
#' 
#' @param p The dimension of the orthogonal matrices.
#' @param n The length of the returned matrix list.
#' @param mat_list A list of already existing orthogonal matrices.
#' @param bestof The number of candidates evaluated for each new matrix.
#' 
#' @return A list which contains the already given and the additionally created matrices.
#'
#' @details If a matrix list should be created from scratch, i.e. the parameter
#' \code{mat_list} was not provided, then the first orthogonal matrix 
#' of the returned list is randomly generated by \code{ICtest::rorth}.
#' If \code{n} is larger than one or if a matrix list was provided, 
#' then for each additional matrix \eqn{M_{k+1}} we consider the distance 
#' \eqn{\min(\textrm{MD}(M_1, M_{k+1}),\textrm{MD}(M_2, M_{k+1}),\dots, \textrm{MD}(M_k, M_{k+1}))}
#' to all previous list entries. This distance is evaluated for \code{bestof} 
#' randomly generated orthogonal candidate matrices from which the
#' furthest is selected.
#' 
#' 
#' @example examples/ex_MD_distant_matrices.R
#' 
#' @seealso ICtest::rorth
#' 
#' @importFrom ICtest rorth
#' @importFrom JADE MD
#' @export
MD_distant_matrices <- function(p, n=1, mat_list=list(), bestof=10){
  if(n <= length(mat_list)){
    return(mat_list)
  }
  for(i in (length(mat_list)+1):n){
    ## when no matrix is given in mat_list, the first matrix can be chosen
    # completely random, meaning as a result of rorth()
    if(i == 1){
      mat_list[[1]] <- ICtest::rorth(p)
    }else{
      largestMD <- 0
      best_cand <- matrix(0, p, p)
      for(j in seq_len(bestof)){
        mat_cand <- ICtest::rorth(p)
        res <- unlist(lapply(mat_list[1:(i-1)], function(x) MD(x, mat_cand)))
        if(min(res) > largestMD){
          best_cand <- mat_cand
          largestMD <- min(res)
        }
      }
      mat_list[[i]] <- best_cand
    }
  }
  return(mat_list)
}

#' Incomplete Cholesky Decomposition
#' 
#' The incomplete Cholesky decomposition, which computes approximative low rank decompositions for either Gauss or Hermite kernel matrices.
#' Its implementation is inspired by Matlab and C code of F. Bach (see references) and written with the C++ library
#' Eigen3 for speed purposes.
#' 
#' @param x Numeric vector.
#' @param kernel One of \code{"gauss"} or \code{"hermite"}.
#' @param eps Numeric precision parameter for the matrix approximation.
#' @param sigma Numeric value, setting the kernel variance. Default is 1 for vectors smaller than n=1000, otherwise 0.5.
#' @param hermite_rank Integer value for the rank of the Hermite kernel. This parameter is ignored, when the Gaussian kernel is chosen. Default is 3.
#' 
#' @return A list containing the following entries: \describe{
#' \item{L}{A numeric matrix which values \eqn{L_{ij}} are \eqn{0} for \eqn{j > i}.}
#' \item{perm}{An integer vector of indices representing the permutation matrix.}
#' }
#' 
#'
#' @details 
#' The function approximates kernel matrices of the form \eqn{\boldsymbol{K} = (K_{ij})_{(i,j)} = K(x_i, x_j)}
#' for a vector \eqn{\boldsymbol{x}} and a kernel function \eqn{K(\cdot, \cdot)}.
#' It returns a permutation matrix \eqn{\boldsymbol{P}} given as index vector and
#' a numeric \eqn{n \times k} matrix \eqn{\boldsymbol{L}} which is a "cut off" lower triangle matrix,
#' as it contains only the first \eqn{k} columns that were necessary to attain a sufficient approximation. 
#' These matrices follow the inequality
#' \eqn{\| \boldsymbol{P} \boldsymbol{K} \boldsymbol{P}^T - \boldsymbol{L} \boldsymbol{L}^T\|_1 \leq \epsilon }
#' where \eqn{\epsilon} is the given precision parameter. The function offers approximation for kernel matrices of the following two kernels:
#' \itemize{
#' \item Gauss Kernel (fix v1.0.1: corrected sign in exponent): \eqn{K(x, y) = e^{-(x-y)^2 / 2 \sigma^2}}
#' \item Hermite Kernel: \eqn{K(x, y) = \sum_{k=0}^d e^{-x^2 / 2 \sigma^2} e^{-y^2 / 2 \sigma^2} \frac{h_k(x / \sigma) h_k(y / \sigma)}{2^k k!}}, 
#' where \eqn{h_k} is the Hermite polynomial of grade \eqn{k}
#' }
#'  
#' @references 
#' 
#' Kernel ICA implementation in Matlab and C by F. Bach containing the Incomplete Cholesky Decomposition:\cr
#' \href{https://www.di.ens.fr/~fbach/kernel-ica/index.htm}{https://www.di.ens.fr/~fbach/kernel-ica/index.htm}
#' 
#' Francis R. Bach, Michael I. Jordan\cr
#' \emph{Predictive low-rank decomposition for kernel methods.}\cr
#' Proceedings of the Twenty-second International Conference on Machine Learning (ICML) 2005\cr
#' \doi{10.1145/1102351.1102356}.
#' 
#' Francis R. Bach, Michael I. Jordan\cr
#' \emph{Kernel independent component analysis}\cr
#' Journal of Machine Learning Research 2002\cr
#' \doi{10.1162/153244303768966085} \cr
#'
#' @example examples/ex_incomplete_cholesky.R
#'  
#' @export
incomplete_cholesky <-
  function(x,
           kernel = c("gauss", "hermite"),
           eps = 0.0001,
           sigma = ifelse(length(x) < 1000, 1, 0.5),
           hermite_rank = 3) {
    kernel <- match.arg(kernel)
    # the c++ wrapper function does not accept integer values from R
    x <- as.numeric(x)
    if(kernel == "gauss"){
      res <- incompleteCholeskyGauss(x, eps, sigma)
    }else if(kernel == "hermite"){
      res <- incompleteCholeskyHermite(x, eps, sigma, hermite_rank)
    }
    return(res)
}

#' Kernel Independent Component Analysis
#'
#' The kernel ICA method by Bach and Jordan (see references).
#' The contrast function was written in C++ under use of the Eigen3 library for computational speed.
#' The package ManifoldOptim is utilized for minimization of the contrast function on the Stiefel manifold.
#'
#' @param x A numeric matrix, where each column contains the measurements of a mixed data source.
#' @param variant Either \code{"kcca"} or \code{"kgv"}.
#' @param kernel Either \code{"gauss"} or \code{"hermite"}.
#' @param nstarts The number of restarts of the kernel ICA method with a default value of one. Ignored, if the starting values
#' in parameter \code{init} are set manually.
#' @param eps Numeric precision parameter for the approximation of the kernel matrices.
#' @param sigma Numeric value of the kernel variance. Default value is 1 for a given x with less than 1000 rows, otherwise 0.5.
#' @param kappa Numeric dimming parameter. Default value is \code{2e^-2} for a given x with less than 1000 rows, otherwise \code{2e^-3}.
#' @param hermite_rank Integer. Rank of the hermite polynomial with a default value of 3. Ignored, when \code{kernel} was set to \code{"gauss"}.
#' @param init A list of \eqn{p \times p} orthogonal matrices, which are the starting points for the optimization in the Stiefel manifold. By default
#' a number of orthogonal matrices specified in parameter \code{nstarts} is generated.
#' @param solver_params An object returned from the method \code{ManifoldOptim::get.solver.params} which can be given several parameters for the optimization.
#' @param optim_method The optimization method used in the Stiefel manifold. Default value is \code{"RSD"}. This value is directly passed to \code{ManifoldOptim::manifold.optim}.
#'
#' @return A class of type \code{bss} containing the following values:
#' \describe{
#' \item{Xmu}{the restored mean values}
#' \item{S}{The unmixed data}
#' \item{W}{The unmixing matrix}
#' \item{cmin}{The smallest resulting contrast function value of all kernel ICA runs}
#' }
#'
#' @details
#' Several points need to be considered when using \code{kernel_ica}:
#' \itemize{
#' \item To comply with the notions of the JADE package, model \eqn{\boldsymbol{X} = \boldsymbol{S} \boldsymbol{A}'}
#' with a \eqn{n \times p} source matrix \eqn{\boldsymbol{S}} and a \eqn{p \times p} mixing matrix \eqn{\boldsymbol{A}} is assumed.
#' \item The returned unmixing matrix \eqn{\boldsymbol{W}} is found such that
#' \eqn{\boldsymbol{X} \boldsymbol{W}' = \boldsymbol{S} \boldsymbol{A}' \boldsymbol{W}'}  results in the desired independent data.
#' \item It is not possible to reconstruct the original order of the sources nor their sign.
#' \item The contrast function which is to be minimized can have several local optimal.
#' Therefore setting the \code{nstart} parameter to a larger value than one or
#' instead providing more matrices in \code{init} for several starts should be considered.
#' \item Kernel ICA is started for each element given in the list \code{init} separately
#' and returns the best result by the lowest resulting value of the contrast function.
#' }
#'
#' @references
#' Kernel ICA implementation in Matlab and C by F. Bach:\cr
#' \href{https://www.di.ens.fr/~fbach/kernel-ica/index.htm}{https://www.di.ens.fr/~fbach/kernel-ica/index.htm}
#'
#' Francis R. Bach, Michael I. Jordan\cr
#' \emph{Kernel independent component analysis}\cr
#' Journal of Machine Learning Research 2002\cr
#' \doi{10.1162/153244303768966085}
#'
#' Sean Martin, Andrew M. Raim, Wen Huang, Kofi P. Adragni\cr
#' \emph{ManifoldOptim: An R Interface to the ROPTLIB Library for Riemannian Manifold Optimization}\cr
#' Journal of Statistical Software 2020\cr
#' \doi{10.18637/jss.v093.i01}
#'
#' @seealso
#' \code{ManifoldOptim::manifold.optim}\cr
#' \code{ManifoldOptim::get.solver.params}
#'
#' @example examples/ex_kernel_ica.R
#'
#' @import Rcpp
#' @importFrom methods new
#' @importFrom stats cov
#' @export
kernel_ica <-
  function(x,
           variant = c("kgv", "kcca"),
           kernel = c("gauss", "hermite"),
           nstarts = 1,
           eps = 0.0001,
           sigma = ifelse(ncol(x) < 1000, 1, 0.5),
           kappa = ifelse(ncol(x) < 1000, 2e-2, 2e-3),
           hermite_rank = 3,
           init = MD_distant_matrices(p = ncol(x), n = nstarts),
           solver_params = ManifoldOptim::get.solver.params(),
           optim_method = "RSD")
  {
    variant <- match.arg(variant)
    if (!(variant %in% c("kgv", "kcca"))) {
      stop("variant argument not valid.")
    }
    
    kernel <- match.arg(kernel)
    if (!(kernel %in% c("gauss", "hermite"))) {
      stop("kernel argument not valid.")
    }
    
    # when a matrix is provided instead of a list with a matrix entry.
    if (is.matrix(init)) {
      init <- list(init)
    }
    # if the argument is neither a matrix nor a list
    else if (!(is.list(init))) {
      stop("invalid argument for init")
    }
    
    p <- ncol(x)
    for (i in seq_along(init)) {
      if (any(dim(init[[i]]) != c(p, p))) {
        stop("wrong dimension of input matrices.")
      }
    }
    
    x <- scale(x, center = TRUE, scale = FALSE)
    x_cov_eigen <- eigen(cov(x), symmetric = TRUE)
    
    whiten <-
      x_cov_eigen$vectors %*% diag(x_cov_eigen$values ^ (-1 / 2)) %*% t(x_cov_eigen$vectors)
    x_whitened <- x %*% whiten
    
    
    par1 = switch(variant,
                  "kcca" = "c",
                  "kgv" = "v")
    
    if (kernel == "gauss") {
      prob <-
        methods::new(mod$KernelICAProblem, x_whitened, eps, kappa, par1, sigma)
    } else{
      # in the case of the Hermite kernel, a different constructor with one additional parameter is called
      prob <-
        methods::new(mod$KernelICAProblem,
                     x_whitened,
                     eps,
                     kappa,
                     par1,
                     sigma,
                     hermite_rank)
    }
    
    
    mani_params <-
      ManifoldOptim::get.manifold.params()
    mani.defn <- ManifoldOptim::get.stiefel.defn(p, p)
    
    
    cmin <- Inf
    Wmin <- matrix(1, nrow = p, ncol = p)
    for (i in seq_along(init)) {
      res <- ManifoldOptim::manifold.optim(
        prob,
        mani.defn,
        method = optim_method,
        mani.params = mani_params,
        solver.params = solver_params,
        x0 = t(init[[i]])
      )
      if (res$fval < cmin) {
        Wmin <- matrix(res$xopt, p)
        cmin <- res$fval
      }
    }
    
    retVal <- list(
      Xmu = attributes(x)$`scaled:center` %*% Wmin,
      S = x %*% Wmin,
      W = t(whiten %*% Wmin),
      cmin = cmin
    )
    class(retVal) <- "bss"
    return(retVal)
  }

#' KernelICA-package
#'
#' The kernel independent component analysis (kernel ICA) method introduced by Bach and Jordan in 2002 (see references).
#' A separate function for the incomplete Cholesky decomposition used in kernel ICA is also provided.
#'
#' @import Rcpp
#' @useDynLib KernelICA
#'
#' @references
#' Francis R. Bach, Michael I. Jordan\cr
#' \emph{Kernel independent component analysis}\cr
#' Journal of Machine Learning Research 2002\cr
#' \doi{10.1162/153244303768966085}
#' 
#' Francis R. Bach, Michael I. Jordan\cr
#' \emph{Predictive low-rank decomposition for kernel methods.}\cr
#' Proceedings of the Twenty-second International Conference on Machine Learning (ICML) 2005\cr
#' \doi{10.1145/1102351.1102356}.
#' 
#' Sean Martin, Andrew M. Raim, Wen Huang, Kofi P. Adragni\cr
#' \emph{ManifoldOptim: An R Interface to the ROPTLIB Library for Riemannian Manifold Optimization}\cr
#' Journal of Statistical Software 2020\cr
#' \doi{10.18637/jss.v093.i01}
"_PACKAGE"

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

incompleteCholeskyGauss <- function(v, eps, sigma) {
    .Call('_KernelICA_incompleteCholeskyGauss', PACKAGE = 'KernelICA', v, eps, sigma)
}

incompleteCholeskyHermite <- function(v, eps, sigma, d) {
    .Call('_KernelICA_incompleteCholeskyHermite', PACKAGE = 'KernelICA', v, eps, sigma, d)
}

kernelMatrixGauss <- function(x, y, sigma) {
    .Call('_KernelICA_kernelMatrixGauss', PACKAGE = 'KernelICA', x, y, sigma)
}

kernelMatrixHermite <- function(x, y, sigma, d) {
    .Call('_KernelICA_kernelMatrixHermite', PACKAGE = 'KernelICA', x, y, sigma, d)
}

#' Kernel Matrix Computation
#' 
#' Computes kernel matrices for Gaussian and Hermitian kernels.
#' 
#' @param x Numeric vector.
#' @param y Numeric vector, default is \code{x}.
#' @param kernel Either \code{"gauss"} or \code{"hermite"}.
#' @param sigma Numeric value of the kernel variance. Default is 1.
#' @param hermite_rank Rank of the Hermite kernel. Default is 3. Ignored, when the Gaussian kernel is chosen.
#' 
#' @details The function computes a matrix in the form of \eqn{(K_{ij})_{(i,j)} = K(x_i, x_j)} or \eqn{(K_{ij})_{(i,j)} = K(x_i, y_j)} 
#' for a kernel function \eqn{K} depending if a second vector was given. The following two kernels are offered:
#' \itemize{
#' \item Gauss Kernel: \eqn{K(x, y) = e^{-(x-y)^2 / 2 \sigma^2}}
#' \item Hermite Kernel: \eqn{K(x, y) = \sum_{k=0}^d e^{-x^2 / 2 \sigma^2} e^{-y^2 / 2 \sigma^2} \frac{h_k(x / \sigma) h_k(y / \sigma)}{2^k k!}}
#' where \eqn{h_k} is the Hermite polynomial of grade \eqn{k}
#' }
#' 
#' @return A numeric kernel matrix.
#' 
#' @example examples/ex_kernel_matrix.R
#'
#' @export
kernel_matrix <-
  function(x, y = x,
           kernel = c("gauss", "hermite"),
           sigma = 1,
           hermite_rank = 3) {
    kernel <- match.arg(kernel)
    # the c++ wrapper function does not accept integer values from R
    x <- as.numeric(x)
    y <- as.numeric(y)
    if(kernel == "gauss"){
      res <- kernelMatrixGauss(x, y, sigma)
    }else if(kernel == "hermite"){
      res <- kernelMatrixHermite(x, y, sigma, hermite_rank)
    }
    return(res)
  }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kernel_ica.R
\name{kernel_ica}
\alias{kernel_ica}
\title{Kernel Independent Component Analysis}
\usage{
kernel_ica(
  x,
  variant = c("kgv", "kcca"),
  kernel = c("gauss", "hermite"),
  nstarts = 1,
  eps = 1e-04,
  sigma = ifelse(ncol(x) < 1000, 1, 0.5),
  kappa = ifelse(ncol(x) < 1000, 0.02, 0.002),
  hermite_rank = 3,
  init = MD_distant_matrices(p = ncol(x), n = nstarts),
  solver_params = ManifoldOptim::get.solver.params(),
  optim_method = "RSD"
)
}
\arguments{
\item{x}{A numeric matrix, where each column contains the measurements of a mixed data source.}

\item{variant}{Either \code{"kcca"} or \code{"kgv"}.}

\item{kernel}{Either \code{"gauss"} or \code{"hermite"}.}

\item{nstarts}{The number of restarts of the kernel ICA method with a default value of one. Ignored, if the starting values
in parameter \code{init} are set manually.}

\item{eps}{Numeric precision parameter for the approximation of the kernel matrices.}

\item{sigma}{Numeric value of the kernel variance. Default value is 1 for a given x with less than 1000 rows, otherwise 0.5.}

\item{kappa}{Numeric dimming parameter. Default value is \code{2e^-2} for a given x with less than 1000 rows, otherwise \code{2e^-3}.}

\item{hermite_rank}{Integer. Rank of the hermite polynomial with a default value of 3. Ignored, when \code{kernel} was set to \code{"gauss"}.}

\item{init}{A list of \eqn{p \times p} orthogonal matrices, which are the starting points for the optimization in the Stiefel manifold. By default
a number of orthogonal matrices specified in parameter \code{nstarts} is generated.}

\item{solver_params}{An object returned from the method \code{ManifoldOptim::get.solver.params} which can be given several parameters for the optimization.}

\item{optim_method}{The optimization method used in the Stiefel manifold. Default value is \code{"RSD"}. This value is directly passed to \code{ManifoldOptim::manifold.optim}.}
}
\value{
A class of type \code{bss} containing the following values:
\describe{
\item{Xmu}{the restored mean values}
\item{S}{The unmixed data}
\item{W}{The unmixing matrix}
\item{cmin}{The smallest resulting contrast function value of all kernel ICA runs}
}
}
\description{
The kernel ICA method by Bach and Jordan (see references).
The contrast function was written in C++ under use of the Eigen3 library for computational speed.
The package ManifoldOptim is utilized for minimization of the contrast function on the Stiefel manifold.
}
\details{
Several points need to be considered when using \code{kernel_ica}:
\itemize{
\item To comply with the notions of the JADE package, model \eqn{\boldsymbol{X} = \boldsymbol{S} \boldsymbol{A}'}
with a \eqn{n \times p} source matrix \eqn{\boldsymbol{S}} and a \eqn{p \times p} mixing matrix \eqn{\boldsymbol{A}} is assumed.
\item The returned unmixing matrix \eqn{\boldsymbol{W}} is found such that
\eqn{\boldsymbol{X} \boldsymbol{W}' = \boldsymbol{S} \boldsymbol{A}' \boldsymbol{W}'}  results in the desired independent data.
\item It is not possible to reconstruct the original order of the sources nor their sign.
\item The contrast function which is to be minimized can have several local optimal.
Therefore setting the \code{nstart} parameter to a larger value than one or
instead providing more matrices in \code{init} for several starts should be considered.
\item Kernel ICA is started for each element given in the list \code{init} separately
and returns the best result by the lowest resulting value of the contrast function.
}
}
\examples{
require(JADE)
require(ICtest)

n <- 2000
p <- 3
S <- matrix(0, n, p)

# the three data sources used in this example
S[, 1] <- rexp(n, rate = 0.4)
S[, 2] <- runif(n, 2, 4)
S[, 3] <- rt(n, 5)

W <- ICtest::rorth(p) # creates an orthogonal matrix
y <- S \%*\% t(W) # mixes the data

# applying kernel ICA method
res <- KernelICA::kernel_ica(y, variant = "kgv", kernel = "hermite")

res$W # unmixing matrix
apply(S, 2, mean) # original means
res$Xmu # restored means (unordered and possibly with different sign each)

# restored data
z <- scale(res$S, center = -res$Xmu, scale = FALSE)
# MD distance of the returned matrix to the original mixing matrix.
JADE::MD(res$W, W)

## Not run:
# Runs kernel ICA with the slower Gauss kernel method and
# a the starting matrix returned from the first method call.
# The maximal iteration number in the optimization is reduced to a tenth.
res2 <- KernelICA::kernel_ica(
  y,
  variant = "kgv",
  kernel = "gauss",
  init = list(res$W),
  solver_params = ManifoldOptim::get.solver.params(Max_Iteration = 100)
)
JADE::MD(res2$W, W)

## End(**Not run**)
}
\references{
Kernel ICA implementation in Matlab and C by F. Bach:\cr
\href{https://www.di.ens.fr/~fbach/kernel-ica/index.htm}{https://www.di.ens.fr/~fbach/kernel-ica/index.htm}

Francis R. Bach, Michael I. Jordan\cr
\emph{Kernel independent component analysis}\cr
Journal of Machine Learning Research 2002\cr
\doi{10.1162/153244303768966085}

Sean Martin, Andrew M. Raim, Wen Huang, Kofi P. Adragni\cr
\emph{ManifoldOptim: An R Interface to the ROPTLIB Library for Riemannian Manifold Optimization}\cr
Journal of Statistical Software 2020\cr
\doi{10.18637/jss.v093.i01}
}
\seealso{
\code{ManifoldOptim::manifold.optim}\cr
\code{ManifoldOptim::get.solver.params}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/package.R
\docType{package}
\name{KernelICA-package}
\alias{KernelICA}
\alias{KernelICA-package}
\title{KernelICA-package}
\description{
The kernel independent component analysis (kernel ICA) method introduced by Bach and Jordan in 2002 (see references).
A separate function for the incomplete Cholesky decomposition used in kernel ICA is also provided.
}
\references{
Francis R. Bach, Michael I. Jordan\cr
\emph{Kernel independent component analysis}\cr
Journal of Machine Learning Research 2002\cr
\doi{10.1162/153244303768966085}

Francis R. Bach, Michael I. Jordan\cr
\emph{Predictive low-rank decomposition for kernel methods.}\cr
Proceedings of the Twenty-second International Conference on Machine Learning (ICML) 2005\cr
\doi{10.1145/1102351.1102356}.

Sean Martin, Andrew M. Raim, Wen Huang, Kofi P. Adragni\cr
\emph{ManifoldOptim: An R Interface to the ROPTLIB Library for Riemannian Manifold Optimization}\cr
Journal of Statistical Software 2020\cr
\doi{10.18637/jss.v093.i01}
}
\author{
\strong{Maintainer}: Klaus Nordhausen \email{klausnordhausenR@gmail.com} (\href{https://orcid.org/0000-0002-3758-8501}{ORCID})

Authors:
\itemize{
  \item Klaus Nordhausen \email{klausnordhausenR@gmail.com} (\href{https://orcid.org/0000-0002-3758-8501}{ORCID})
  \item Christoph L. Koesner \email{christoph@koesner.at} (\href{https://orcid.org/0000-0002-2061-8022}{ORCID})
  \item Juho Eagling \email{juho.eagling@gmail.com} (\href{https://orcid.org/0000-0001-8333-5057}{ORCID})
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/kernel_matrix.R
\name{kernel_matrix}
\alias{kernel_matrix}
\title{Kernel Matrix Computation}
\usage{
kernel_matrix(
  x,
  y = x,
  kernel = c("gauss", "hermite"),
  sigma = 1,
  hermite_rank = 3
)
}
\arguments{
\item{x}{Numeric vector.}

\item{y}{Numeric vector, default is \code{x}.}

\item{kernel}{Either \code{"gauss"} or \code{"hermite"}.}

\item{sigma}{Numeric value of the kernel variance. Default is 1.}

\item{hermite_rank}{Rank of the Hermite kernel. Default is 3. Ignored, when the Gaussian kernel is chosen.}
}
\value{
A numeric kernel matrix.
}
\description{
Computes kernel matrices for Gaussian and Hermitian kernels.
}
\details{
The function computes a matrix in the form of \eqn{(K_{ij})_{(i,j)} = K(x_i, x_j)} or \eqn{(K_{ij})_{(i,j)} = K(x_i, y_j)} 
for a kernel function \eqn{K} depending if a second vector was given. The following two kernels are offered:
\itemize{
\item Gauss Kernel: \eqn{K(x, y) = e^{-(x-y)^2 / 2 \sigma^2}}
\item Hermite Kernel: \eqn{K(x, y) = \sum_{k=0}^d e^{-x^2 / 2 \sigma^2} e^{-y^2 / 2 \sigma^2} \frac{h_k(x / \sigma) h_k(y / \sigma)}{2^k k!}}
where \eqn{h_k} is the Hermite polynomial of grade \eqn{k}
}
}
\examples{
x <- rnorm(10)
kernel_matrix(x, kernel = "gauss", sigma = 4)
kernel_matrix(x, kernel = "hermite", sigma = 4, hermite_rank = 3)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/incomplete_cholesky.R
\name{incomplete_cholesky}
\alias{incomplete_cholesky}
\title{Incomplete Cholesky Decomposition}
\usage{
incomplete_cholesky(
  x,
  kernel = c("gauss", "hermite"),
  eps = 1e-04,
  sigma = ifelse(length(x) < 1000, 1, 0.5),
  hermite_rank = 3
)
}
\arguments{
\item{x}{Numeric vector.}

\item{kernel}{One of \code{"gauss"} or \code{"hermite"}.}

\item{eps}{Numeric precision parameter for the matrix approximation.}

\item{sigma}{Numeric value, setting the kernel variance. Default is 1 for vectors smaller than n=1000, otherwise 0.5.}

\item{hermite_rank}{Integer value for the rank of the Hermite kernel. This parameter is ignored, when the Gaussian kernel is chosen. Default is 3.}
}
\value{
A list containing the following entries: \describe{
\item{L}{A numeric matrix which values \eqn{L_{ij}} are \eqn{0} for \eqn{j > i}.}
\item{perm}{An integer vector of indices representing the permutation matrix.}
}
}
\description{
The incomplete Cholesky decomposition, which computes approximative low rank decompositions for either Gauss or Hermite kernel matrices.
Its implementation is inspired by Matlab and C code of F. Bach (see references) and written with the C++ library
Eigen3 for speed purposes.
}
\details{
The function approximates kernel matrices of the form \eqn{\boldsymbol{K} = (K_{ij})_{(i,j)} = K(x_i, x_j)}
for a vector \eqn{\boldsymbol{x}} and a kernel function \eqn{K(\cdot, \cdot)}.
It returns a permutation matrix \eqn{\boldsymbol{P}} given as index vector and
a numeric \eqn{n \times k} matrix \eqn{\boldsymbol{L}} which is a "cut off" lower triangle matrix,
as it contains only the first \eqn{k} columns that were necessary to attain a sufficient approximation. 
These matrices follow the inequality
\eqn{\| \boldsymbol{P} \boldsymbol{K} \boldsymbol{P}^T - \boldsymbol{L} \boldsymbol{L}^T\|_1 \leq \epsilon }
where \eqn{\epsilon} is the given precision parameter. The function offers approximation for kernel matrices of the following two kernels:
\itemize{
\item Gauss Kernel (fix v1.0.1: corrected sign in exponent): \eqn{K(x, y) = e^{-(x-y)^2 / 2 \sigma^2}}
\item Hermite Kernel: \eqn{K(x, y) = \sum_{k=0}^d e^{-x^2 / 2 \sigma^2} e^{-y^2 / 2 \sigma^2} \frac{h_k(x / \sigma) h_k(y / \sigma)}{2^k k!}}, 
where \eqn{h_k} is the Hermite polynomial of grade \eqn{k}
}
}
\examples{
# approximation of a Gauss kernel matrix
x <- rnorm(500)
x_kernel_mat <- kernel_matrix(x, sigma = 1)
x_chol <- incomplete_cholesky(x, sigma = 1)
L_perm <- x_chol$L[x_chol$perm, ]
x_kernel_approx <- L_perm \%*\% t(L_perm)
## largest differing value:
max(abs(x_kernel_approx - x_kernel_mat))


# approximation of a Hermite kernel matrix
x_kernel_mat <- kernel_matrix(x, kernel = "hermite", sigma = 0.5)
x_chol <- incomplete_cholesky(x, kernel = "hermite", sigma = 0.5)
L_perm <- x_chol$L[x_chol$perm, ]
x_kernel_approx <- L_perm \%*\% t(L_perm)
## largest differing value:
max(abs(x_kernel_approx - x_kernel_mat))
}
\references{
Kernel ICA implementation in Matlab and C by F. Bach containing the Incomplete Cholesky Decomposition:\cr
\href{https://www.di.ens.fr/~fbach/kernel-ica/index.htm}{https://www.di.ens.fr/~fbach/kernel-ica/index.htm}

Francis R. Bach, Michael I. Jordan\cr
\emph{Predictive low-rank decomposition for kernel methods.}\cr
Proceedings of the Twenty-second International Conference on Machine Learning (ICML) 2005\cr
\doi{10.1145/1102351.1102356}.

Francis R. Bach, Michael I. Jordan\cr
\emph{Kernel independent component analysis}\cr
Journal of Machine Learning Research 2002\cr
\doi{10.1162/153244303768966085} \cr
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MD_distant_matrices.R
\name{MD_distant_matrices}
\alias{MD_distant_matrices}
\title{MD Distant Matrices}
\usage{
MD_distant_matrices(p, n = 1, mat_list = list(), bestof = 10)
}
\arguments{
\item{p}{The dimension of the orthogonal matrices.}

\item{n}{The length of the returned matrix list.}

\item{mat_list}{A list of already existing orthogonal matrices.}

\item{bestof}{The number of candidates evaluated for each new matrix.}
}
\value{
A list which contains the already given and the additionally created matrices.
}
\description{
Creates orthogonal matrices in the Stiefel manifold, which are distant to each other
by the MD index and optionally also distant to a given set of matrices.
}
\details{
If a matrix list should be created from scratch, i.e. the parameter
\code{mat_list} was not provided, then the first orthogonal matrix 
of the returned list is randomly generated by \code{ICtest::rorth}.
If \code{n} is larger than one or if a matrix list was provided, 
then for each additional matrix \eqn{M_{k+1}} we consider the distance 
\eqn{\min(\textrm{MD}(M_1, M_{k+1}),\textrm{MD}(M_2, M_{k+1}),\dots, \textrm{MD}(M_k, M_{k+1}))}
to all previous list entries. This distance is evaluated for \code{bestof} 
randomly generated orthogonal candidate matrices from which the
furthest is selected.
}
\examples{
# creates one orthogonal 3x3 matrix (result of ICtest::rorth(3)), wrapped in a list
MD_distant_matrices(3, 1)

# creates a 4x4 matrix, distant to the unit matrix and returns both
MD_distant_matrices(4, 2, mat_list = list(diag(4)))

# creates two orthogonal 3x3 matrices with more candidates to get better distances.
m <- MD_distant_matrices(3, 2, bestof = 20)
JADE::MD(m[[1]], m[[2]])
}
\seealso{
ICtest::rorth
}
